﻿using DevExpress.Xpf.Core;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;
using TimeTecAPIDemo.Model;

namespace TimeTecAPIDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : DevExpress.Xpf.Core.DXWindow
    {
        public static double currentSecond = 0;
        System.Windows.Forms.NotifyIcon ni = new System.Windows.Forms.NotifyIcon();

        public MainWindow()
        {
            try
            {
                InitializeComponent();

                #region Refresh Interval
                System.Timers.Timer timer = new System.Timers.Timer();
                timer.AutoReset = true;
                timer.Elapsed += new System.Timers.ElapsedEventHandler(loginTimer_Elapsed);
                if (Function.refreshinterval != "")
                {
                    timer.Interval = Convert.ToDouble(Function.refreshinterval) * 60 * 1000;
                }
                else
                {
                    timer.Interval = 1800000; // 1800000 miliseconds = 30mins;
                }
                timer.Enabled = true;
                #endregion

                #region Set notification area icon
                ni.Icon = new System.Drawing.Icon("Images/favicon16x16.ico");
                ni.Text = "TimeTec API";
                ni.Visible = true;
                ni.DoubleClick +=
                    delegate(object sender, EventArgs args)
                    {
                        this.Show();
                        ni.Visible = false;
                        this.WindowState = WindowState.Normal;
                    };
                #endregion
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }

        protected override void OnStateChanged(EventArgs e)
        {
            if (WindowState == System.Windows.WindowState.Minimized)
            {
                ni.Visible = true;
                ni.ShowBalloonTip(1000, "TimeTec API", "Minimized to tray", System.Windows.Forms.ToolTipIcon.Info);
                this.Hide();
            }

            base.OnStateChanged(e);
        }

        private void loginTimer_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            try
            {
                Function.RefreshSDK();
            }
            catch { }
        }

        public static void DoEvents()// process messsages
        {
            Application.Current.Dispatcher.Invoke(DispatcherPriority.Background, new Action(delegate { }));
        }
    }
}
