﻿using DevExpress.Xpf.Core;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web.Script.Serialization;

namespace TimeTecAPIDemo.Model
{
    class Function
    {
        #region Item Source Variable
        public static string ApiLimit = "";
        public static object terminalinforesult = null;
        public static object userinforesult = null;
        public static object userinfobyidresult = null;
        public static object auditdataresult = null;
        public static object logresult = null;
        public static object fingerprintresult9 = null;
        public static object fingerprintresult10 = null;
        public static object attendanceresult = null;
        public static object leavetyperesult = null;
        public static string lastupdate = "";
        public static int totalterminal = 0;
        public static int totaluser = 0;
        public static string refreshinterval = "";
        public static List<LicenseObj> availablelicense = null;
        #endregion

        #region Fingerprint Variable
        public static string FingerprintUserID = "";
        public static string FingerprintAlgoVer = "";
        #endregion

        #region Audit Data Variable
        public static string AuditDataUserID = "";
        public static string AuditDataCheckTimeFrom = "";
        public static string AuditDataCheckTimeTo = "";
        public static string AuditDataRecordStartFrom = "";
        public static string AuditDataLimitRecordShow = "";
        #endregion

        #region Log Variable
        public static string LogUserID = "";
        public static string LogCheckTimeFrom = "";
        public static string LogCheckTimeTo = "";
        public static string LogRecordStartFrom = "";
        public static string LogLimitRecordShow = "";
        #endregion

        #region Terminal User Info Variable
        public static string SerialNo = "";
        public static string currentPage = "";
        #endregion

        #region Attendance Variable
        public static string AttendanceUserID = "";
        public static string AttendanceCheckTimeFrom = "";
        public static string AttendanceCheckTimeTo = "";
        public static string AttendanceRecordStartFrom = "";
        public static string AttendanceLimitRecordShow = "";
        #endregion

        #region LeaveType Variable
        public static string LeaveType = "";
        #endregion

        #region UserLeave Variable
        public static string UserLeaveUserID = "";
        public static string UserLeaveCheckTimeFrom = "";
        public static string UserLeaveCheckTimeTo = "";
        #endregion

        #region User Variable
        public static string UserID = "";
        public static string Name = "";
        public static string Alias = "";
        public static string Gender = "";
        public static string DOB = "";
        public static string Nationality = "";
        public static string Race = "";
        public static string NationalID = "";
        public static string Religion = "";
        public static string HomeAddress = "";
        public static string MobileContact = "";
        public static string PersonalEmail = "";
        public static string EmploymentID = "";
        public static string Designation = "";
        public static string SSI = "";
        public static string JoinedDate = "";
        public static string Branch = "";
        public static string Department = "";
        public static string Section = "";
        public static string GroupDutyRoster = "";
        public static string RateHour = "";
        public static string TimeZone = "";
        public static string Remark = "";
        public static string TimeTecUserID="";
        public static string IssuanceDate = "";
        public static string ExpiryDate = "";
        public static string LiveChat = "";
        public static string Suspended = "";
        #endregion

        #region Initialize Webservice
        static WebServiceSDK.WebServiceTimeTecAPISoapClient WS = new WebServiceSDK.WebServiceTimeTecAPISoapClient();
        static WebServiceSDK.WebServiceSoapHeader SoapHeader = new WebServiceSDK.WebServiceSoapHeader();
        #endregion

        #region Return Webservice result
        public static object LoadDataFromWebservice(string FunctionName)
        {
            string ErrorMessage = "";
            object Result = null;
            JavaScriptSerializer js = new JavaScriptSerializer();
            Dictionary<string, object> JsonResult = new Dictionary<string, object>();
            Dictionary<string, object> WSResult = new Dictionary<string, object>();

            try
            {
                switch (FunctionName)
                {
                    case "UserInfo":
                        UserInfoResult result2 = GetFunction_UserInfo();
                        if (result2 != null)
                        {
                            Result = result2.UsersObj;
                            Function.totaluser = result2.UsersObj.Count;
                        }
                        break;
                    case "TerminalInfo":
                        TerminalInfoResult result3 = GetFunction_TerminalInfo();
                        if (result3 != null)
                        {
                            Result = result3.TerminalInfoObj;
                            Function.totalterminal = result3.TerminalInfoObj.Count;
                        }
                        break;
                    case "CompanyID":
                        CompanyIDResult result4 = GetFunction_CompanyID();
                        if (result4 != null)
                            Result = result4.CompanyID;
                        break;
                    case "ApiLimit":
                        ApiLimitResult result5 = GetFunction_ApiLimit();
                        if (result5 != null)
                            Result = result5.ApiLimitObj;
                        break;
                    case "License":
                        LicenseResult result6 = GetFunction_License();
                        if (result6 != null)
                        {
                            Result = result6.LicenseObj;
                            availablelicense = Result as List<LicenseObj>;
                        }
                        break;
                    case "AuditData":
                        AuditDataResult result7 = GetFunction_AuditData();
                        if (result7 != null)
                        {
                            Result = result7.AuditDataObj;
                        }
                        break;
                    case "AllLog":
                        AllLogResult result8 = GetFunction_AllLog();
                        if (result8 != null)
                        {
                            Result = result8.AllLogsObj;
                        }
                        break;
                    case "Log":
                        LogResult result9 = GetFunction_Log();
                        if (result9 != null)
                        {
                            Result = result9.LogObj;
                        }
                        break;
                    case "Fingerprint":
                        FingerprintResult result10 = GetFunction_Fingerprint();
                        if (result10 != null)
                        {
                            Result = result10.FingerprintObj;
                        }
                        break;
                    case "Logout":
                        LogoutResult result11 = GetFunction_Logout();
                        if (result11 != null)
                        {
                            Result = result11;
                        }
                        break;
                    case "TerminalUserInfo":
                        TerminalUserInfoResult result12 = GetFunction_TerminalUserInfo();
                        if (result12 != null)
                        {
                            Result = result12.TerminalUserInfoObj;
                        }
                        break;
                    case "AllAttendance":
                        AllAttendanceResult result13 = GetFunction_AllAttendance();
                        if (result13 != null)
                        {
                            Result = result13.AllAttendanceObj;
                        }
                        break;
                    case "Attendance":
                        AttendanceResult result14 = GetFunction_Attendance();
                        if (result14 != null)
                        {
                            Result = result14.AttendanceObj;
                        }
                        break;
                    case "LeaveType":
                        LeaveTypeResult result15 = GetFunction_LeaveType();
                        if (result15 != null)
                        {
                            Result = result15.LeaveTypeObj;
                        }
                        break;
                    case "UserInfoByID":
                        UserInfoByIDResult result16 = GetFunction_UserInfoByID();
                        if (result16 != null)
                        {
                            Result = result16.UserInfoObj;
                        }
                        break;
                }
            }
            catch (SystemException e)
            {
                ErrorMessage = e.Message;
            }
            return Result;
        }
        #endregion

        #region Call Webservice Get functions
        public static T GetJSONData<T>(string FunctionName) where T : new()
        {
            JavaScriptSerializer js = new JavaScriptSerializer();
            
            string json_data = string.Empty;

            try
            {
                if (Login.SecurityToken != "")
                {
                    SoapHeader.SecurityToken = Login.SecurityToken;

                    switch (FunctionName)
                    {
                        case "AllTerminalUserInfo": json_data = WS.GetAllTerminalUserInfo(SoapHeader, Login.CompanyID);
                            break;
                        case "UserInfo": json_data = WS.GetAllUserInfo(SoapHeader, Login.CompanyID);
                            break;
                        case "UserInfoByID": json_data = WS.GetUserInfo(SoapHeader, Login.CompanyID, UserID);
                            break;
                        case "TerminalInfo": json_data = WS.GetTerminalInfo(SoapHeader, Login.CompanyID);
                            break;
                        case "CompanyID": json_data = WS.GetCompanyID(SoapHeader);
                            break;
                        case "ApiLimit": json_data = WS.GetApiLimit(SoapHeader, Login.CompanyID);
                            break;
                        case "License": json_data = WS.GetAvailableLicense(SoapHeader, Login.CompanyID);
                            break;
                        case "AuditData": json_data = WS.GetAuditData(SoapHeader, Login.CompanyID, AuditDataUserID, AuditDataCheckTimeFrom, AuditDataCheckTimeTo, AuditDataRecordStartFrom, AuditDataLimitRecordShow);
                            break;
                        case "AllLog": json_data = WS.GetAllLog(SoapHeader, Login.CompanyID, LogCheckTimeFrom, LogCheckTimeTo, LogRecordStartFrom, LogLimitRecordShow);
                            break;
                        case "Log": json_data = WS.GetLog(SoapHeader, Login.CompanyID, LogUserID, LogCheckTimeFrom, LogCheckTimeTo, LogRecordStartFrom, LogLimitRecordShow);
                            break;
                        case "Fingerprint": json_data = WS.GetFingerprint(SoapHeader, Login.CompanyID, FingerprintUserID, FingerprintAlgoVer);
                            break;
                        case "Logout": json_data = WS.WebServiceLogout(SoapHeader, Login.SecurityToken);
                            break;
                        case "TerminalUserInfo": json_data = WS.GetTerminalUserInfo(SoapHeader, Login.CompanyID, Function.SerialNo);
                            break;
                        case "AllAttendance": json_data = WS.GetAllAttendance(SoapHeader, Login.CompanyID, AttendanceCheckTimeFrom, AttendanceCheckTimeTo, AttendanceRecordStartFrom, AttendanceLimitRecordShow);
                            break;
                        case "Attendance": json_data = WS.GetAttendance(SoapHeader, Login.CompanyID, AttendanceUserID, AttendanceCheckTimeFrom, AttendanceCheckTimeTo, AttendanceRecordStartFrom, AttendanceLimitRecordShow);
                            break;
                        case "LeaveType": json_data = WS.GetLeaveType(SoapHeader, Login.CompanyID);
                            break;
                    }
                }

                Dictionary<string, object> JsonResult = js.Deserialize<Dictionary<string, object>>(json_data);
                Login.ErrorMessage = JsonResult["ErrorMessage"].ToString();
            }
            catch (SystemException e)
            {
                Login.ErrorMessage = e.Message;
            }

            if (Login.ErrorMessage == "")
            {
                return !string.IsNullOrEmpty(json_data) ? js.Deserialize<T>(json_data) : new T();
            }
            else
            {
                return new T();
            }
        }
        #endregion

        #region Call Webservice Set functions
        public static string SetJSONData<T>(string FunctionName) where T : new()
        {
            JavaScriptSerializer js = new JavaScriptSerializer();
            string json_data = string.Empty;

            try
            {
                if (Login.SecurityToken != "")
                {
                    SoapHeader.SecurityToken = Login.SecurityToken;

                    switch (FunctionName)
                    {
                        case "AddLeaveType": json_data = WS.AddLeaveType(SoapHeader, Login.CompanyID, LeaveType);
                            break;
                        case "SetUserLeave": json_data = WS.SetUserLeave(SoapHeader, Login.CompanyID, UserLeaveUserID, LeaveType, UserLeaveCheckTimeFrom, UserLeaveCheckTimeTo, "");
                            break;
                        case "UpdateUser": json_data = WS.UpdateUser(SoapHeader, Login.CompanyID, UserID, Name, Alias, Gender, DOB, Nationality, Race, NationalID, Religion, HomeAddress, MobileContact, PersonalEmail, EmploymentID, Designation, SSI, JoinedDate, Branch, Department, Section, GroupDutyRoster, RateHour, TimeZone, Remark, IssuanceDate, ExpiryDate, 0);
                            break;
                        case "AddUser": json_data = WS.AddUser(SoapHeader, Login.CompanyID, Name, Alias, Gender, DOB, Nationality, Race, NationalID, Religion, HomeAddress, MobileContact, PersonalEmail, EmploymentID, Designation, SSI, JoinedDate, Branch, Department, Section, GroupDutyRoster, RateHour, TimeZone, Remark,TimeTecUserID, IssuanceDate, ExpiryDate, 0);
                            break; 
                    }
                }

                Dictionary<string, object> JsonResult = js.Deserialize<Dictionary<string, object>>(json_data);
                Login.ErrorMessage = JsonResult["ErrorMessage"].ToString();
            }
            catch (SystemException e)
            {
                Login.ErrorMessage = e.Message;
            }

            return Login.ErrorMessage;
        }
        #endregion

        #region GetFunction
        public static TerminalInfoResult GetFunction_TerminalInfo()
        {
            var TerminalInfoList = GetJSONData<TerminalInfoJsonObject>("TerminalInfo");
            return (TerminalInfoResult)TerminalInfoList.Result;
        }

        public static UserInfoResult GetFunction_UserInfo()
        {
            var UserInfoList = GetJSONData<UserInfoJsonObject>("UserInfo");
            return (UserInfoResult)UserInfoList.Result;
        }

        public static UserInfoByIDResult GetFunction_UserInfoByID()
        {
            var UserInfoList = GetJSONData<UserInfoByIDJsonObject>("UserInfoByID");
            return (UserInfoByIDResult)UserInfoList.Result;
        }

        public static CompanyIDResult GetFunction_CompanyID()
        {
            var CompanyIDList = GetJSONData<CompanyIDJsonObject>("CompanyID");
            return (CompanyIDResult)CompanyIDList.Result;
        }

        public static ApiLimitResult GetFunction_ApiLimit()
        {
            var ApiLimitList = GetJSONData<ApiLimitJsonObject>("ApiLimit");
            return (ApiLimitResult)ApiLimitList.Result;
        }

        public static LicenseResult GetFunction_License()
        {
            var LicenseList = GetJSONData<LicenseJsonObject>("License");
            return (LicenseResult)LicenseList.Result;
        }

        public static AuditDataResult GetFunction_AuditData()
        {
            var AuditDataList = GetJSONData<AuditDataJsonObject>("AuditData");
            return (AuditDataResult)AuditDataList.Result;
        }

        public static LogResult GetFunction_Log()
        {
            var LogList = GetJSONData<LogJsonObject>("Log");
            return (LogResult)LogList.Result;
        }

        public static AllLogResult GetFunction_AllLog()
        {
            var AllLogList = GetJSONData<AllLogJsonObject>("AllLog");
            return (AllLogResult)AllLogList.Result;
        }

        public static TerminalUserInfoResult GetFunction_TerminalUserInfo()
        {
            var TerminalUserInfoList = GetJSONData<TerminalUserInfoJsonObject>("TerminalUserInfo");
            return (TerminalUserInfoResult)TerminalUserInfoList.Result;
        }

        public static FingerprintResult GetFunction_Fingerprint()
        {
            var FingerprintList = GetJSONData<FingerprintJsonObject>("Fingerprint");
            return (FingerprintResult)FingerprintList.Result;
        }

        public static LogoutResult GetFunction_Logout()
        {
            var LogoutList = GetJSONData<LogoutJsonObject>("Logout");
            return (LogoutResult)LogoutList.Result;
        }

        public static AttendanceResult GetFunction_Attendance()
        {
            var AttendanceList = GetJSONData<AttendanceJsonObject>("Attendance");
            return (AttendanceResult)AttendanceList.Result;
        }

        public static AllAttendanceResult GetFunction_AllAttendance()
        {
            var AllAttendanceList = GetJSONData<AllAttendanceJsonObject>("AllAttendance");
            return (AllAttendanceResult)AllAttendanceList.Result;
        }

        public static LeaveTypeResult GetFunction_LeaveType()
        {
            var LeaveTypeList = GetJSONData<LeaveTypeJsonObject>("LeaveType");
            return (LeaveTypeResult)LeaveTypeList.Result;
        }
        #endregion

        #region SetFunction
        public static string SetFunction_AddLeaveType()
        {
            var ErrorMessage = SetJSONData<SetModelJsonObject>("AddLeaveType");
            return ErrorMessage.ToString();
        }

        public static string SetFunction_SetUserLeave()
        {
            var ErrorMessage = SetJSONData<SetModelJsonObject>("SetUserLeave");
            return ErrorMessage.ToString();
        }

        public static string SetFunction_UpdateUser()
        {
            var ErrorMessage = SetJSONData<SetModelJsonObject>("UpdateUser");
            return ErrorMessage.ToString();
        }

        public static string SetFunction_AddUser()
        {
            var ErrorMessage = SetJSONData<SetModelJsonObject>("AddUser");
            return ErrorMessage.ToString();
        }
        #endregion

        #region Refresh SDK
        public static void RefreshSDK()
        {
            auditdataresult = null;
            logresult = null;

            //Get User Info
            userinforesult = LoadDataFromWebservice("UserInfo");

            //Get Terminal Info
            terminalinforesult = LoadDataFromWebservice("TerminalInfo");

            //Get Api Limit
            ApiLimitObj a = LoadDataFromWebservice("ApiLimit") as ApiLimitObj;
            if (a != null)
                Function.ApiLimit = a.ApiLimit.ToString();

            //Get Available License
            availablelicense = LoadDataFromWebservice("License") as List<LicenseObj>;

            lastupdate = DateTime.Now.ToString("yyyy-MM-dd hh:mm:ss tt");
        }
        #endregion

        public static List<string> GetTimeZoneList()
        {
            List<string> listtimezone = new List<string>();

            // zone -12 to -4
            for (int i = 12; i >= 4; i--)
            {
                if (i >= 10)
                    listtimezone.Add("UTC-" + i + ":00");
                else
                    listtimezone.Add("UTC-0" + i + ":00");
            }

            listtimezone.Add("UTC-04:30");
            listtimezone.Add("UTC-04:00");
            listtimezone.Add("UTC-03:30");
            listtimezone.Add("UTC-03:00");
            listtimezone.Add("UTC-02:00");
            listtimezone.Add("UTC-01:00");
            listtimezone.Add("UTC 00:00");

            // zone 1 to 3
            for (int i = 1; i <= 3; i++)
                listtimezone.Add("UTC+0" + i + ":00");

            // zone 3:30 to 9:30
            listtimezone.Add("UTC+03:30");
            listtimezone.Add("UTC+04:00");
            listtimezone.Add("UTC+04:30");
            listtimezone.Add("UTC+05:00");
            listtimezone.Add("UTC+05:30");
            listtimezone.Add("UTC+05:45");
            listtimezone.Add("UTC+06:00");
            listtimezone.Add("UTC+06:30");
            listtimezone.Add("UTC+07:00");
            listtimezone.Add("UTC+08:00");
            listtimezone.Add("UTC+09:00");
            listtimezone.Add("UTC+09:30");

            // zone 10 to 13
            for (int i = 10; i <= 13; i++)
                listtimezone.Add("UTC+" + i + ":00");

            return listtimezone;
        }
    }
}
