﻿using DevExpress.Xpf.Editors;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using TimeTecAPIDemo.Model;

namespace TimeTecAPIDemo
{
    /// <summary>
    /// Interaction logic for SetUserLeave.xaml
    /// </summary>
    public partial class SetUserLeave
    {
        public SetUserLeave()
        {
            InitializeComponent();
        }

        private void DXWindow_MouseDown(object sender, MouseButtonEventArgs e)
        {
            if (e.ChangedButton == MouseButton.Left)
                DragMove();
        }

        private void btnClose_Click(object sender, RoutedEventArgs e)
        {
            Close();
        }

        private void cbLeaveType_Loaded(object sender, RoutedEventArgs e)
        {
            Function.leavetyperesult = Function.LoadDataFromWebservice("LeaveType");
            List<LeaveTypeObj> list = new List<LeaveTypeObj>();
            List<string> data = new List<string>();
            

            if (Function.leavetyperesult != null)
            {
                list = (List<LeaveTypeObj>)Function.leavetyperesult;
                data.Add("");

                for (int i = 0; i < list.Count; i++)
                {
                    LeaveTypeObj leavetypeobject = list[i] as LeaveTypeObj;
                    data.Add(leavetypeobject.LeaveType);
                }
                var comboBox = sender as ComboBoxEdit;
                comboBox.ItemsSource = data;
                comboBox.SelectedIndex = 0;
            }
        }

        private void btnSubmit_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                if (txtUserID.Text != "")
                {
                    Function.UserLeaveUserID = txtUserID.Text;

                    if (cbLeaveType.EditValue != null)
                    {
                        Function.LeaveType = cbLeaveType.Text;
                    }

                    if (deCheckTimeFrom.EditValue != null && deCheckTimeTo.EditValue != null)
                    {
                        DateTime CheckTimeFrom = Convert.ToDateTime(deCheckTimeFrom.EditValue);
                        DateTime CheckTimeTo = Convert.ToDateTime(deCheckTimeTo.EditValue);
                        int DaysInMonth = DateTime.DaysInMonth(CheckTimeFrom.Year, CheckTimeFrom.Month);
                        if (CheckTimeFrom <= CheckTimeTo)
                        {
                            TimeSpan timespan = CheckTimeTo.Subtract(CheckTimeFrom);
                            int daycount = Convert.ToInt32(timespan.Days);

                            if (daycount <= DaysInMonth)
                            {
                                Function.UserLeaveCheckTimeFrom = Convert.ToDateTime(CheckTimeFrom).ToString("yyyy-MM-dd");
                                Function.UserLeaveCheckTimeTo = Convert.ToDateTime(CheckTimeTo).ToString("yyyy-MM-dd");

                                string ErrorMessage = Function.SetFunction_SetUserLeave();

                                if (ErrorMessage != "")
                                    MessageBox.Show(ErrorMessage);
                                else
                                {
                                    Close();
                                    MessageBox.Show("User leave submitted successfully");
                                }
                            }
                            else
                            {
                                MessageBox.Show("Maximum period is one month");
                            }
                        }
                        else
                        {
                            MessageBox.Show("Check Time To must be greater than Check Time From");
                        }
                    }
                    else
                    {
                        MessageBox.Show("Please select a valid date");
                    }
                }
                else
                {
                    MessageBox.Show("Please enter User ID");
                }

                
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }
    }
}
