﻿using DevExpress.Internal.DXWindow;
using DevExpress.Xpf.Grid;
using DevExpress.Xpf.WindowsUI;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TimeTecAPIDemo.Model;

namespace TimeTecAPIDemo
{
    /// <summary>
    /// Interaction logic for TerminalInfo.xaml
    /// </summary>
    public partial class TerminalInfo : UserControl
    {
        public TerminalInfo()
        {
            InitializeComponent();
            copyright.Text = copyright.Text.Replace("2015", DateTime.Now.Year.ToString());
        }

        #region Button Functions
        private void btnClose_Click(object sender, RoutedEventArgs e)
        {
            Window parentWindow = Window.GetWindow(this);
            parentWindow.Close();
        }

        private void btnMinimize_Click(object sender, RoutedEventArgs e)
        {
            Window parentWindow = Window.GetWindow(this);
            parentWindow.WindowState = WindowState.Minimized;
        }

        private void btnRefreshGrid_Click(object sender, RoutedEventArgs e)
        {
            if (Function.currentPage == "TerminalInfoGrid")
            {
                FrameworkElement rootElement = LayoutHelper.FindRoot((DependencyObject)e.OriginalSource) as FrameworkElement;
                GridControl grid = LayoutHelper.FindElement(rootElement, element => element is GridControl && (element.Name == "grid")) as GridControl;

                try
                {
                    Function.terminalinforesult = Function.LoadDataFromWebservice("TerminalInfo");
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
                grid.BeginDataUpdate();
                grid.ItemsSource = Function.terminalinforesult;
                grid.EndDataUpdate();
                grid.RefreshData();
            }
            else if (Function.currentPage == "TerminalUserInfo")
            {
                object terminaluserinforesult = null;
                FrameworkElement rootElement = LayoutHelper.FindRoot((DependencyObject)e.OriginalSource) as FrameworkElement;
                GridControl grid = LayoutHelper.FindElement(rootElement, element => element is GridControl && (element.Name == "grid")) as GridControl;

                try
                {
                    terminaluserinforesult = Function.LoadDataFromWebservice("TerminalUserInfo");
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
                grid.BeginDataUpdate();
                grid.ItemsSource = terminaluserinforesult;
                grid.EndDataUpdate();
                grid.RefreshData();
            }
        }
        #endregion
    }
}
