﻿using DevExpress.Xpf.Grid;
using DevExpress.Xpf.WindowsUI;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using TimeTecAPIDemo.Model;

namespace TimeTecAPIDemo
{
    /// <summary>
    /// Interaction logic for TerminalInfoGrid.xaml
    /// </summary>
    public partial class TerminalInfoGrid : UserControl
    {
        public TerminalInfoGrid()
        {
            InitializeComponent();
            LoadData();
            Function.currentPage = "TerminalInfoGrid";
        }

        public void LoadData()
        {
            this.Cursor = Cursors.Wait;
            BackgroundWorker worker = new BackgroundWorker();
            worker.RunWorkerAsync();
            worker.DoWork += delegate(object s, DoWorkEventArgs args)
            {
                try
                {
                    #region Initialize table User Info
                    if (Function.terminalinforesult == null)
                    {
                        Function.terminalinforesult = Function.LoadDataFromWebservice("TerminalInfo");
                    }
                    #endregion
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            };
            worker.RunWorkerCompleted += delegate(object s, RunWorkerCompletedEventArgs args)
            {
                grid.BeginDataUpdate();
                grid.ItemsSource = Function.terminalinforesult;
                grid.EndDataUpdate();
                grid.RefreshData();
                this.Cursor = Cursors.Arrow;
            };
            while (worker.IsBusy)
            {
                System.Threading.Thread.Sleep(100);
                MainWindow.DoEvents();
            }
        }

        private void grid_MouseDoubleClick(object sender, MouseButtonEventArgs e)
        {
            int rowHandle = tableView.GetRowHandleByMouseEventArgs(e);
            if (rowHandle == GridControl.InvalidRowHandle) return;

            string serialNo = grid.GetFocusedRowCellDisplayText("serialno");
            Function.SerialNo = serialNo;

            TerminalUserInfo page = new TerminalUserInfo();
            var frame = DevExpress.Xpf.Core.Native.LayoutHelper.FindParentObject<NavigationFrame>(this);
            frame.Navigate(page);
        }

    }
}
